#version 150 compatibility
#extension GL_ARB_explicit_attrib_location : enable

uniform sampler2D tex;
uniform sampler2D lightmap;
uniform sampler2D normals;
uniform sampler2D specular;

in vec2 lmcoord;
in vec2 texcoord;
in vec4 viewPos;
in vec4 tint;

flat in vec3 normal;
flat in mat3 tbn;

flat in float id;

/* RENDERTARGETS: 0,1,2,3,10 */

#include "/lib/includes.glsl"

void main() {
	vec4 color = texture(tex, texcoord);
	color *= tint;
	float lmapY = texture(lightmap, lmcoord).y;
	// color.rgb *= lmapY;
	color.rgb = pow(color.rgb, vec3(2.2));

	vec3 normalCol = texture(normals, texcoord).rgb*2.0-1.0;

	float normalAO = normalCol.z;

    normalCol.z = sqrt(1.0-dot(normalCol.xy, normalCol.xy));
	
	normalCol *= tbn;

    vec4 specularTex = texture(specular, texcoord);

    specularTex.r = pow2(1.0 - specularTex.r); //Convert the perceptual smoothness to linear roughness
	
	specularTex.g *= 255;

	vec2 outLMCoord = lmcoord;
	
	// vec3 dFdViewposX = dFdx(viewPos.xyz);
	// vec3 dFdViewposY = dFdy(viewPos.xyz);

	// vec2 dFdLight = vec2(dFdx(lmcoord.r), dFdy(lmcoord.r));
	// vec2 dFdSky = vec2(dFdx(lmcoord.g), dFdy(lmcoord.g));

	// vec3 lightDir = dFdViewposX * dFdLight.x + dFdViewposY * dFdLight.y;
	// vec3 skyLightDir = dFdViewposX * dFdSky.x + dFdViewposY * dFdSky.y;

	// outLMCoord.r *= mix(clamp01(dot(normalize(lightDir), normalCol) + 0.8) * 0.8 + 0.2, clamp01(dot(tbn * vec3(0.0, 0.0, 1.0), normal)), float(length(dFdLight) <= 1e-6));
	// outLMCoord.g *= mix(clamp01(dot(normalize(skyLightDir), normalCol) + 0.8) * 0.8 + 0.2, clamp01(dot(vec3(0.0, 1.0, 0.0), normal) + 0.8) * 0.4 + 0.6, float(length(dFdSky) <= 1e-6));

	// outLMCoord = clamp(outLMCoord, rcp(32.0), 31.0/32.0);

	gl_FragData[0] = color;
	gl_FragData[1] = vec4(normalCol, normalAO);
	gl_FragData[2] = vec4(outLMCoord, 0.0, 1.0);
	gl_FragData[3] = vec4(normal.xy*0.5+0.5, id/65535,tint.a);
	gl_FragData[4] = specularTex;
}
